//redFrik 2010
//released under gnu gpl license

//related: RedWirelessMaster, KretsloppKontroll
//todo: gui (or separate gui class RedThermoKontrollGUI?)

RedThermoKontroll {
	var	<master, <>debug= false,
		<swiOn, <>swiOnAction, swiOnLastTime,
		<swiUp, <>swiUpAction, swiUpLastTime, swiUpLast,
		<capa0, <>capa0Action,	capa0LastTime,
		<capa1, <>capa1Action,	capa1LastTime,
		<satz0, <>satz0Action, satz0LastTime, satz0Last,
		<satz1, <>satz1Action, satz1LastTime, satz1Last,
		<numb0, <>numb0Action, numb0LastTime, numb0Last,
		<numb1, <>numb1Action, numb1LastTime, numb1Last,
		<numb2, <>numb2Action, numb2LastTime, numb2Last,
		<numb3, <>numb3Action, numb3LastTime, numb3Last,
		<eeeuu, <>eeeuuAction, eeeuuLastTime, eeeuuLast,
		<screw, <>screwAction, screwLastTime, screwLast,
		<fein0, <>fein0Action, fein0Last,
		<fein1, <>fein1Action, fein1Last,
		<grob0, <>grob0Action, grob0Last,
		<grob1, <>grob1Action, grob1Last,
		<light, <>lightAction, lightLast;
	*new {|master|
		^super.new.initRedThermoKontroll(master);
	}
	initRedThermoKontroll {|argMaster|
		var dataLast= Array.fill(16, 0);
		master= argMaster;
		if(master.port.isNil, {
			(this.class.name++": master not initialised/connected - skipping").error;
			^this;
		});
		master.radioActive= true;
		swiOnLastTime= SystemClock.seconds;
		swiUpLastTime= SystemClock.seconds;
		capa0LastTime= SystemClock.seconds;
		capa1LastTime= SystemClock.seconds;
		satz0LastTime= SystemClock.seconds;
		satz1LastTime= SystemClock.seconds;
		numb0LastTime= SystemClock.seconds;
		numb1LastTime= SystemClock.seconds;
		numb2LastTime= SystemClock.seconds;
		numb3LastTime= SystemClock.seconds;
		eeeuuLastTime= SystemClock.seconds;
		screwLastTime= SystemClock.seconds;
		CmdPeriod.doOnce({master.radioActive= false});
		master.action= {|data|
			var diff;
			
			if(data[0]==1, {						//check that device is redThermoKontroll
				
				if(debug, {data.postln});
				
				//--analog inputs
				if(data[1]!=dataLast[1], {			//satz1
					case
						{data[1]==255} {satz1= 0}
						{data[1]==238 or:{data[1]==237}} {satz1= 1}
						{data[1]==231 or:{data[1]==232}} {satz1= 2}
						{data[1]==209} {satz1= 3}
						{data[1]==197 or:{data[1]==196}} {satz1= 4}
						{data[1]==181 or:{data[1]==180}} {satz1= 5}
						{data[1]==158} {satz1= 6}
						{data[1]==143 or:{data[1]==142}} {satz1= 7}
						{data[1]==130 or:{data[1]==131}} {satz1= 8}
						{data[1]==119} {satz1= 9}
						{data[1]==100 or:{data[1]==101}} {satz1= 10}
						{data[1]==83 or:{data[1]==84}} {satz1= 11}
						{data[1]==65} {satz1= 12}
						{data[1]==47} {satz1= 13}
						{data[1]==23} {satz1= 14}
						{data[1]==16} {satz1= 15}
						{data[1]==11} {satz1= 16}
						{data[1]==8 or:{data[1]==7}} {satz1= 17}
						{data[1]==5} {satz1= 18}
						{data[1]==2} {satz1= 19}
						{data[1]==0} {satz1= 20}
						{satz1= nil};
					if(satz1.notNil and:{satz1!=satz1Last}, {
						satz1Action.value(satz1, SystemClock.seconds-satz1LastTime, satz1Last);
						satz1LastTime= SystemClock.seconds;
						satz1Last= satz1;
					});
				});
				if(data[2]!=dataLast[2], {			//satz0
					case
						{data[2]==242} {satz0= 0}
						{data[2]==231} {satz0= 1}
						{data[2]==192} {satz0= 2}
						{data[2]==130 or:{data[2]==131}} {satz0= 3}
						{data[2]==84} {satz0= 4}
						{data[2]==47} {satz0= 5}
						{data[2]==16} {satz0= 6}
						{data[2]==7 or:{data[2]==8}} {satz0= 7}
						{data[2]==5} {satz0= 8}
						{data[2]==0} {satz0= 9}
						{satz0= nil};
					if(satz0.notNil and:{satz0!=satz0Last}, {
						satz0Action.value(satz0, SystemClock.seconds-satz0LastTime, satz0Last);
						satz0LastTime= SystemClock.seconds;
						satz0Last= satz0;
					});
				});
				
				if(data[3]!=dataLast[3], {			//numb0
					case
						{data[3]==238} {numb0= 10}
						{data[3]==231} {numb0= 9}
						{data[3]==181 or:{data[3]==180}} {numb0= 8}
						{data[3]==130} {numb0= 7}
						{data[3]==83 or:{data[3]==84}} {numb0= 6}
						{data[3]==47} {numb0= 5}
						{data[3]==23} {numb0= 4}
						{data[3]==16} {numb0= 3}
						{data[3]==7 or:{data[3]==8}} {numb0= 2}
						{data[3]==5} {numb0= 1}
						{data[3]==0} {numb0= 0}
						{numb0= nil};
					if(numb0.notNil and:{numb0!=numb0Last}, {
						numb0Action.value(numb0, SystemClock.seconds-numb0LastTime, numb0Last);
						numb0LastTime= SystemClock.seconds;
						numb0Last= numb0;
					});
				});
				if(data[4]!=dataLast[4], {			//numb1
					case
						{data[4]==238 or:{data[4]==237}} {numb1= 10}
						{data[4]==231} {numb1= 9}
						{data[4]==181 or:{data[4]==180}} {numb1= 8}
						{data[4]==130} {numb1= 7}
						{data[4]==83} {numb1= 6}
						{data[4]==47} {numb1= 5}
						{data[4]==23} {numb1= 4}
						{data[4]==16} {numb1= 3}
						{data[4]==7 or:{data[4]==8}} {numb1= 2}
						{data[4]==5} {numb1= 1}
						{data[4]==0} {numb1= 0}
						{numb1= nil};
					if(numb1.notNil and:{numb1!=numb1Last}, {
						numb1Action.value(numb1, SystemClock.seconds-numb1LastTime, numb1Last);
						numb1LastTime= SystemClock.seconds;
						numb1Last= numb1;
					});
				});
				if(data[5]!=dataLast[5], {			//numb2
					case
						{data[5]==238} {numb2= 10}
						{data[5]==231} {numb2= 9}
						{data[5]==180} {numb2= 8}
						{data[5]==131} {numb2= 7}
						{data[5]==84 or:{data[5]==85}} {numb2= 6}
						{data[5]==47} {numb2= 5}
						{data[5]==23} {numb2= 4}
						{data[5]==16} {numb2= 3}
						{data[5]==7 or:{data[5]==8}} {numb2= 2}
						{data[5]==5} {numb2= 1}
						{data[5]==0} {numb2= 0}
						{numb2= nil};
					if(numb2.notNil and:{numb2!=numb2Last}, {
						numb2Action.value(numb2, SystemClock.seconds-numb2LastTime, numb2Last);
						numb2LastTime= SystemClock.seconds;
						numb2Last= numb2;
					});
				});
				if(data[6]!=dataLast[6], {			//numb3
					case
						{data[6]==238 or:{data[6]==237}} {numb3= 10}
						{data[6]==231} {numb3= 9}
						{data[6]==180} {numb3= 8}
						{data[6]==131} {numb3= 7}
						{data[6]==84 or:{data[6]==85}} {numb3= 6}
						{data[6]==47 or:{data[6]==48}} {numb3= 5}
						{data[6]==23} {numb3= 4}
						{data[6]==16} {numb3= 3}
						{data[6]==7 or:{data[6]==8}} {numb3= 2}
						{data[6]==5} {numb3= 1}
						{data[6]==0} {numb3= 0}
						{numb3= nil};
					if(numb3.notNil and:{numb3!=numb3Last}, {
						numb3Action.value(numb3, SystemClock.seconds-numb3LastTime, numb3Last);
						numb3LastTime= SystemClock.seconds;
						numb3Last= numb3;
					});
				});
				if(data[7]!=dataLast[7], {			//eeeuu
					case
						{data[7]==0} {eeeuu= 0}
						{data[7]==5} {eeeuu= 1}
						{data[7]==16 or:{data[7]==17}} {eeeuu= 2}
						{data[7]==47} {eeeuu= 3}
						{data[7]==83 or:{data[7]==84}} {eeeuu= 4}
						{data[7]==130} {eeeuu= 5}
						{data[7]==231} {eeeuu= 6}
						{data[7]==238} {eeeuu= 7}
						{eeeuu= nil};
					if(eeeuu.notNil and:{eeeuu!=eeeuuLast}, {
						eeeuuAction.value(eeeuu, SystemClock.seconds-eeeuuLastTime, eeeuuLast);
						eeeuuLastTime= SystemClock.seconds;
						eeeuuLast= eeeuu;
					});
				});
				if(data[8]!=dataLast[8], {			//screw
					case
						{data[8]==255} {screw= 0}
						{data[8]==128 or:{data[8]==129}} {screw= 1}
						{data[8]==83 or:{data[8]==84}} {screw= 2}
						{data[8]==47 or:{data[8]==48}} {screw= 3}
						{data[8]==15 or:{data[8]==16}} {screw= 4}
						{data[8]==10 or:{data[8]==11}} {screw= 5}
						{data[8]==7 or:{data[8]==8}} {screw= 6}
						{data[8]==4 or:{data[8]==5}} {screw= 7}
						{data[8]==1 or:{data[8]==2}} {screw= 8}
						{screw= nil};
					if(screw.notNil and:{screw!=screwLast}, {
						screwAction.value(screw, SystemClock.seconds-screwLastTime, screwLast);
						screwLastTime= SystemClock.seconds;
						screwLast= screw;
					});
				});
				if(data[9]!=dataLast[9], {			//fein0
					fein0Last= fein0;
					fein0= data[9].linlin(0, 106, 255, 0).round.asInteger;
					fein0Action.value(fein0);
				});
				if(data[10]!=dataLast[10], {		//grob0
					grob0Last= grob0;
					grob0= data[10].linlin(0, 107, 255, 0).round.asInteger;
					grob0Action.value(grob0);
				});
				if(data[11]!=dataLast[11], {		//fein1
					fein1Last= fein1;
					fein1= data[11].linlin(0, 108, 255, 0).round.asInteger;
					fein1Action.value(fein1);
				});
				if(data[12]!=dataLast[12], {		//grob1
					grob1Last= grob1;
					grob1= data[12].linlin(0, 112, 255, 0).round.asInteger;
					grob1Action.value(grob1);
				});
				if(data[13]!=dataLast[13], {		//light
					lightLast= light;
					light= data[13];
					lightAction.value(light);
				});
				
				//--digital switches
				diff= data[14].bitXor(dataLast[14]);
				if(diff&1==1, {					//swiOn
					swiOn= 0xff-data[14]&1;
					swiOnAction.value(swiOn, SystemClock.seconds-swiOnLastTime);
					swiOnLastTime= SystemClock.seconds;
				});
				if(diff&2==2 or:{diff&4==4}, {		//swiUp
					swiUp= ((0xff-data[14]).rightShift(1)&3).wrap(-1, 1).neg;
					swiUpAction.value(swiUp, SystemClock.seconds-swiUpLastTime, swiUpLast);
					swiUpLastTime= SystemClock.seconds;
					swiUpLast= swiUp;
				});
				if(diff&8==8, {					//capa0
					capa0= (0xff-data[14]).rightShift(3)&1;
					capa0Action.value(capa0, SystemClock.seconds-capa0LastTime);
					capa0LastTime= SystemClock.seconds;
				});
				if(diff&16==16, {					//capa1
					capa1= (0xff-data[14]).rightShift(4)&1;
					capa1Action.value(capa1, SystemClock.seconds-capa1LastTime);
					capa1LastTime= SystemClock.seconds;
				});
				
				dataLast= data;
			});
		};
	}
	makeWindow {
		//todo
	}
}
