//redFrik 2010, 2013
//released under gnu gpl license

RedThermoKontrollTest : RedThermoKontroll {
	var potSatz1, potGrob0, potGrob1;
	var potSatz0, potFein0, potFein1, potEeeuu;
	var potNumb0, potNumb1, potNumb2, potNumb3;
	var sldLight, sldSwiUp;
	var butScrew, butCapa0, butCapa1, butSwiOn;
	
	initRedThermoKontroll {|argMaster|
		var dataLast= Array.fill(16, 0);
		swiOnLastTime= SystemClock.seconds;
		swiUpLastTime= SystemClock.seconds;
		capa0LastTime= SystemClock.seconds;
		capa1LastTime= SystemClock.seconds;
		satz0LastTime= SystemClock.seconds;
		satz1LastTime= SystemClock.seconds;
		numb0LastTime= SystemClock.seconds;
		numb1LastTime= SystemClock.seconds;
		numb2LastTime= SystemClock.seconds;
		numb3LastTime= SystemClock.seconds;
		eeeuuLastTime= SystemClock.seconds;
		screwLastTime= SystemClock.seconds;
		
	}
	makeWindow {|position|
		var numSatz1, numGrob0, numGrob1;
		var numSatz0, numFein0, numFein1, numEeeuu;
		var numNumb0, numNumb1, numNumb2, numNumb3;
		var win, fnt= Font("Monaco", 9);
		position= position ?? {Point(500, 200)};
		win= Window(this.class.name, Rect(position.x, position.y, 360, 320), false);
		win.view.background= Color.red;
		win.view.decorator= FlowLayout(win.bounds);
		
		butScrew= Array.fill(8, {|i|
			Button(win, Rect(0, 0, 25, 20))			//screw
				.states_([[(8-i).asString, Color.red, Color.black], [(8-i).asString, Color.red, Color.white]])
				.action_({|view|
					screw= view.value*(8-i);
					screwAction.value(screw, SystemClock.seconds-screwLastTime, screwLast);
					screwLastTime= SystemClock.seconds;
					screwLast= screw;
				}).canFocus_(false);
		});
		win.view.decorator.shift(20, 0);
		butCapa0= Button(win, Rect(0, 0, 40, 20))		//capa0
			.states_([["capa0", Color.red, Color.black], ["capa0", Color.red, Color.white]])
			.action_({|view|
				capa0= view.value;
				capa0Action.value(capa0, SystemClock.seconds-capa0LastTime);
				capa0LastTime= SystemClock.seconds;
			}).canFocus_(false);
		butCapa1= Button(win, Rect(0, 0, 40, 20))		//capa1
			.states_([["capa1", Color.red, Color.black], ["capa1", Color.red, Color.white]])
			.action_({|view|
				capa1= view.value;
				capa1Action.value(capa1, SystemClock.seconds-capa1LastTime);
				capa1LastTime= SystemClock.seconds;
			}).canFocus_(false);
		
		//--
		win.view.decorator.nextLine;
		potSatz1= Knob(win, Rect(0, 0, 70, 70))		//satz1
			.action_({|view|
				view.value= view.value.round(1/20);
				if((view.value*20).round.asInteger!=satz1, {
					satz1= (view.value*20).round.asInteger;
					numSatz1.value= satz1;
					satz1Action.value(satz1, SystemClock.seconds-satz1LastTime, satz1Last);
					satz1LastTime= SystemClock.seconds;
					satz1Last= satz1;
				});
			}).canFocus_(false);
		potGrob0= Knob(win, Rect(0, 0, 70, 70))		//grob0
			.action_({|view|
				view.value= view.value.round(1/255);
				grob0= (view.value*255).round.asInteger;
				numGrob0.value= grob0;
				grob0Action.value(grob0);
			}).canFocus_(false);
		potGrob1= Knob(win, Rect(0, 0, 70, 70))		//grob1
			.action_({|view|
				view.value= view.value.round(1/255);
				grob1= (view.value*255).round.asInteger;
				numGrob1.value= grob1;
				grob1Action.value(grob1);
			}).canFocus_(false);
		win.view.decorator.shift(20, 0);
		butSwiOn= Button(win, Rect(0, 0, 40, 20))		//swiOn
			.states_([["swiOn", Color.red, Color.black], ["swiOn", Color.red, Color.white]])
			.action_({|view|
				swiOn= view.value;
				swiOnAction.value(swiOn, SystemClock.seconds-swiOnLastTime);
				swiOnLastTime= SystemClock.seconds;
			}).canFocus_(false);
		win.view.decorator.nextLine;
		numSatz1= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 20);
				view.value= val;
				potSatz1.valueAction= val/20;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("satz1");
		numGrob0= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 255);
				view.value= val;
				potGrob0.valueAction= val/255;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("grob0");
		numGrob1= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 255);
				view.value= val;
				potGrob1.valueAction= val/255;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("grob1");
		win.view.decorator.nextLine;
		
		//--
		win.view.decorator.nextLine;
		potSatz0= Knob(win, Rect(0, 0, 70, 70))		//satz0
			.action_({|view|
				view.value= view.value.round(1/9);
				if((view.value*9).round.asInteger!=satz0, {
					satz0= (view.value*9).round.asInteger;
					numSatz0.value= satz0;
					satz0Action.value(satz0, SystemClock.seconds-satz0LastTime, satz0Last);
					satz0LastTime= SystemClock.seconds;
					satz0Last= satz0;
				});
			}).canFocus_(false);
		potFein0= Knob(win, Rect(0, 0, 70, 70))		//fein0
			.action_({|view|
				view.value= view.value.round(1/255);
				fein0= (view.value*255).round.asInteger;
				numFein0.value= fein0;
				fein0Action.value(fein0);
			}).canFocus_(false);
		potFein1= Knob(win, Rect(0, 0, 70, 70))		//fein1
			.action_({|view|
				view.value= view.value.round(1/255);
				fein1= (view.value*255).round.asInteger;
				numFein1.value= fein1;
				fein1Action.value(fein1);
			}).canFocus_(false);
		sldLight= Slider(win, Rect(0, 0, 50, 60))		//light
			.action_({|view|
				view.value= view.value.round(1/255);
				light= (view.value*255).round.asInteger;
				lightAction.value(light);
			}).canFocus_(false)
			.value_(1);
		potEeeuu= Knob(win, Rect(0, 0, 70, 70))		//eeeuu
			.action_({|view|
				view.value= view.value.round(1/7);
				if((view.value*7).round.asInteger!=eeeuu, {
					eeeuu= (view.value*7).round.asInteger;
					numEeeuu.value= eeeuu;
					eeeuuAction.value(eeeuu, SystemClock.seconds-eeeuuLastTime, eeeuuLast);
					eeeuuLastTime= SystemClock.seconds;
					eeeuuLast= eeeuu;
				});
			}).canFocus_(false);
		win.view.decorator.nextLine;
		numSatz0= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 9);
				view.value= val;
				potSatz0.valueAction= val/9;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("satz0");
		numFein0= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 255);
				view.value= val;
				potFein0.valueAction= val/255;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("fein0");
		numFein1= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 255);
				view.value= val;
				potFein1.valueAction= val/255;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("fein1");
		StaticText(win, Rect(0, 0, 50, 15)).string_("light");
		numEeeuu= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 7);
				view.value= val;
				potEeeuu.valueAction= val/7;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("eeeuu");
		
		//--
		win.view.decorator.nextLine;
		sldSwiUp= Slider(win, Rect(0, 0, 50, 60))		//swiUp
			.action_({|view|
				view.value= view.value.round(0.5);
				if((view.value*2-1).round.asInteger!=swiUp, {
					swiUp= (view.value*2-1).round.asInteger;
					swiUpAction.value(swiUp, SystemClock.seconds-swiUpLastTime, swiUpLast);
					swiUpLastTime= SystemClock.seconds;
					swiUpLast= swiUp;
				});
			}).canFocus_(false)
			.value_(0.5);
		potNumb0= Knob(win, Rect(0, 0, 70, 70))		//numb0
			.action_({|view|
				view.value= view.value.round(1/10);
				if((view.value*10).round.asInteger!=numb0, {
					numb0= (view.value*10).round.asInteger;
					numNumb0.value= numb0;
					numb0Action.value(numb0, SystemClock.seconds-numb0LastTime, numb0Last);
					numb0LastTime= SystemClock.seconds;
					numb0Last= numb0;
				});
			}).canFocus_(false);
		potNumb1= Knob(win, Rect(0, 0, 70, 70))		//numb1
			.action_({|view|
				view.value= view.value.round(1/10);
				if((view.value*10).round.asInteger!=numb1, {
					numb1= (view.value*10).round.asInteger;
					numNumb1.value= numb1;
					numb1Action.value(numb1, SystemClock.seconds-numb1LastTime, numb1Last);
					numb1LastTime= SystemClock.seconds;
					numb1Last= numb1;
				});
			}).canFocus_(false);
		potNumb2= Knob(win, Rect(0, 0, 70, 70))		//numb2
			.action_({|view|
				view.value= view.value.round(1/10);
				if((view.value*10).round.asInteger!=numb2, {
					numb2= (view.value*10).round.asInteger;
					numNumb2.value= numb2;
					numb2Action.value(numb2, SystemClock.seconds-numb2LastTime, numb2Last);
					numb2LastTime= SystemClock.seconds;
					numb2Last= numb2;
				});
			}).canFocus_(false);
		potNumb3= Knob(win, Rect(0, 0, 70, 70))		//numb3
			.action_({|view|
				view.value= view.value.round(1/10);
				if((view.value*10).round.asInteger!=numb3, {
					numb3= (view.value*10).round.asInteger;
					numNumb3.value= numb3;
					numb3Action.value(numb3, SystemClock.seconds-numb3LastTime, numb3Last);
					numb3LastTime= SystemClock.seconds;
					numb3Last= numb3;
				});
			}).canFocus_(false);
		win.view.decorator.nextLine;
		StaticText(win, Rect(0, 0, 50, 15)).string_("swiUp");
		numNumb0= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 10);
				view.value= val;
				potNumb0.valueAction= val/10;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("numb0");
		numNumb1= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 10);
				view.value= val;
				potNumb1.valueAction= val/10;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("numb1");
		numNumb2= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 10);
				view.value= val;
				potNumb2.valueAction= val/10;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("numb2");
		numNumb3= NumberBox(win, Rect(0, 0, 26, 15))
			.action_({|view|
				var val= view.value.asInteger.clip(0, 10);
				view.value= val;
				potNumb3.valueAction= val/10;
			}).value_(0);
		StaticText(win, Rect(0, 0, 40, 15)).string_("numb3");
		
		win.view.children.do{|x|
			if(x.respondsTo('font_'), {
				x.font= fnt;
			});
		};
		win.front;
		CmdPeriod.doOnce({
			if(win.isClosed.not, {
				win.close;
			});
		});
	}
}

/*
~kontroll= RedThermoKontrollTest.new;
~kontroll.makeWindow;
*/